xml-conduit-1.4.0.2: Pure-Haskell utilities for dealing with XML with the conduit package.

Safe Haskell | None
Language | Haskell98

Text.XML.Unresolved

Contents

- Non-streaming functions
- Lazy bytestrings
- Text
- Byte streams
- Streaming functions
- Exceptions
- Settings
  - Parse
  - Render

Description

DOM-based XML parsing and rendering.

In this module, attribute values and content nodes can contain either raw text or entities. In most cases, these can be fully resolved at parsing. If that is the case for your documents, the Text.XML module provides simplified datatypes that only contain raw text.

Synopsis

- writeFile :: RenderSettings -> FilePath -> Document -> IO ()
- readFile :: ParseSettings -> FilePath -> IO Document
- renderLBS :: RenderSettings -> Document -> ByteString
- parseLBS :: ParseSettings -> ByteString -> Either SomeException Document
- parseLBS_ :: ParseSettings -> ByteString -> Document
- parseText :: ParseSettings -> Text -> Either SomeException Document
- parseText_ :: ParseSettings -> Text -> Document
- sinkTextDoc :: MonadThrow m => ParseSettings -> Consumer Text m Document
- sinkDoc :: MonadThrow m => ParseSettings -> Consumer ByteString m Document
- toEvents :: Document -> [Event]
- elementToEvents :: Element -> [Event]
- fromEvents :: MonadThrow m => Consumer EventPos m Document
- elementFromEvents :: MonadThrow m => Consumer EventPos m (Maybe Element)
- renderBuilder :: Monad m => RenderSettings -> Document -> Producer m Builder
- renderBytes :: (PrimMonad base, MonadBase base m) => RenderSettings -> Document -> ConduitM a ByteString m ()
- renderText :: (PrimMonad base, MonadBase base m, MonadThrow m) => RenderSettings -> Document -> ConduitM a Text m ()
- data InvalidEventStream
  - = ContentAfterRoot EventPos
  - | MissingRootElement
  - | InvalidInlineDoctype EventPos
  - | MissingEndElement Name (Maybe EventPos)
  - | UnterminatedInlineDoctype
- def :: Default a => a
- data ParseSettings
- psDecodeEntities :: ParseSettings -> DecodeEntities
- psRetainNamespaces :: ParseSettings -> Bool
- data RenderSettings
- rsPretty :: RenderSettings -> Bool
- rsNamespaces :: RenderSettings -> [(Text, Text)]

# Non-streaming functions

writeFile :: RenderSettings -> FilePath -> Document -> IO () #

readFile :: ParseSettings -> FilePath -> IO Document #

# Lazy bytestrings

renderLBS :: RenderSettings -> Document -> ByteString #

parseLBS :: ParseSettings -> ByteString -> Either SomeException Document #

parseLBS_ :: ParseSettings -> ByteString -> Document #

# Text

parseText :: ParseSettings -> Text -> Either SomeException Document #

parseText_ :: ParseSettings -> Text -> Document #

sinkTextDoc :: MonadThrow m => ParseSettings -> Consumer Text m Document #

# Byte streams

sinkDoc :: MonadThrow m => ParseSettings -> Consumer ByteString m Document #

# Streaming functions

toEvents :: Document -> [Event] #

Render a document into events.

elementToEvents :: Element -> [Event] #

Render a document element into events.

Since: 1.3.5

fromEvents :: MonadThrow m => Consumer EventPos m Document #

Parse a document from a stream of events.

elementFromEvents :: MonadThrow m => Consumer EventPos m (Maybe Element) #

Try to parse a document element (as defined in XML) from a stream of events.

Since: 1.3.5

renderBuilder :: Monad m => RenderSettings -> Document -> Producer m Builder #

renderBytes :: (PrimMonad base, MonadBase base m) => RenderSettings -> Document -> ConduitM a ByteString m () #

renderText :: (PrimMonad base, MonadBase base m, MonadThrow m) => RenderSettings -> Document -> ConduitM a Text m () #

# Exceptions

data InvalidEventStream #

Constructors

ContentAfterRoot EventPos |
MissingRootElement |
InvalidInlineDoctype EventPos |
MissingEndElement Name (Maybe EventPos) |
UnterminatedInlineDoctype |

Instances

Show InvalidEventStream # |
Methods showsPrec :: Int -> InvalidEventStream -> ShowS # show :: InvalidEventStream -> String # showList :: [InvalidEventStream] -> ShowS #
Exception InvalidEventStream # |
Methods toException :: InvalidEventStream -> SomeException # fromException :: SomeException -> Maybe InvalidEventStream # displayException :: InvalidEventStream -> String #

# Settings

def :: Default a => a #

The default value for this type.

## Parse

data ParseSettings #

Instances

Default ParseSettings # |
Methods def :: ParseSettings #

psDecodeEntities :: ParseSettings -> DecodeEntities #

psRetainNamespaces :: ParseSettings -> Bool #

Whether the original xmlns attributes should be retained in the parsed values. For more information on motivation, see:

https://github.com/snoyberg/xml/issues/38

Default: False

Since 1.2.1

## Render

data RenderSettings #

Instances

Default RenderSettings # |
Methods def :: RenderSettings #

rsPretty :: RenderSettings -> Bool #

rsNamespaces :: RenderSettings -> [(Text, Text)] #

Defines some top level namespace definitions to be used, in the form of (prefix, namespace). This has absolutely no impact on the meaning of your documents, but can increase readability by moving commonly used namespace declarations to the top level.